#include "h_Estimation.h"
#include "k_Util.h"
#include "d_Rules_816.h"

//-----------------------------------------------------------------------------------
/* +
 *  
 *
 *  ChessTerminator75
 *   3.1.2008
 *  
 *   
 *         d_Loop
*/
//---------------------------------------------------------------------------

//     
//        
//      
int Pozicion[] ={
                 0,
				 100,100,100,100,100,100,100,100,
 		         110,120,120,100,100,120,120,110,
 		         110,120,140,140,140,140,120,110,
 		         110,120,140,130,130,140,120,110,
 		         110,120,140,130,130,140,120,110,
 		         110,120,140,100,100,140,120,110,
 		         110,120,120,120,120,120,120,110,
 		         100,100,100,100,100,100,100,100,
 		         };

int Pozicion_r[] ={
                 0,
				 100,100,100,100,100,100,100,100,
 		         100,100,100,100,100,100,100,100,
 		         100,100,100,100,100,100,100,100,
 		         100,100,100,100,100,100,100,100,
 		         100,100,100,100,100,100,100,100,
 		         100,100,100,100,100,100,100,100,
 		         100,100,100,100,100,100,100,100,
 		         100,100,100,100,100,100,100,100,
 		         };
 
//      
//           
int Pawn[] ={
	         0,
	         44,46,48,50,51,49,47,45,
		     36,38,40,42,43,41,39,37,
		     28,30,31,34,35,33,32,29,
		     20,21,22,23,24,27,26,25,
		     0,0,0,18,19,0,0,0,
		     0,0,0,10,11,0,0,0,
		     0,0,0,0,0,0,0,0,
		     0,0,0,0,0,0,0,0
		     };

 //    
 //   
 int Castling[]={
	         0,
	         0,0,30,0,0,0,50,0,
		     0,0,0,0,0,0,0,0,
		     0,0,0,0,0,0,0,0,
		     0,0,0,0,0,0,0,0,
		     0,0,0,0,0,0,0,0,
		     0,0,0,0,0,0,0,0,
		     0,0,0,0,0,0,0,0,
		     0,0,30,0,0,0,50,0
		     };
//	===================================================================
//     (  ) 
void Eval_root_816(T_board_list_816 * board_list_816){


static  int ocenka=0;
static  int zv=0;//  
static  int dz=0;
static  int n_1 = 0;
static  int x=0;
static  int y=0;
static short int name_figure=0;

 n_1 = 0;
 ocenka=0;

while (n_1<120){
    if (!(n_1 & 0x88)&&(board_list_816->colour_figure_816[n_1]!=0)){	
//          
//          
// 0-  1- 2- 3- 4- 5- 6-          
y = n_1/16+1;
x= n_1%16+1;
//        
zv= board_list_816->colour_figure_816[n_1]==1 ? 1 : -1;

//  
name_figure=board_list_816->name_figure_816[n_1];

          switch (name_figure){
//--------------------------------------------------------------------------------------
//  
           case 2 :// 
              ocenka= ocenka+zv*500;
              ocenka= ocenka+zv*xy_board_out(1,x,y,Pozicion_r);
              ocenka= ocenka+zv*2*Rook_amoun_816(n_1,board_list_816);

              break;
           case 3 :// 
              ocenka= ocenka+zv*300;
              ocenka= ocenka+zv*xy_board_out(1,x,y,Pozicion);
              break;
           case 4 :// 
              ocenka= ocenka+zv*300;
              ocenka= ocenka+zv*xy_board_out(1,x,y,Pozicion);
              ocenka= ocenka+zv*2*Bishop_amoun_816(n_1,board_list_816);
              break;
           case 5 :// 
              ocenka= ocenka+zv*1000;
              ocenka= ocenka+zv*xy_board_out(1,x,y,Pozicion_r);
              break;
           case 6 :// 
           	  ocenka= ocenka+zv*900000;
              ocenka= ocenka+zv*xy_board_out(1,x,y,Castling);
              break;
           case 1 :// 
              dz= board_list_816->colour_figure_816[n_1]==1 ? 1 : 0;
              ocenka=ocenka+zv*100;
              ocenka=ocenka+zv*(dz*xy_board_out(1,x,y,Pawn)+(1-dz)*xy_board_out(1,x,9-y,Pawn));
              break;
//--------------------------------------------------------------------------------------
           default:
            break;
        }//switch
 }//if ((board_list_816.colour_figure_816[n_1]!=3)&&(board_list_816.colour_figure_816[n]!=0)){	
  n_1 = n_1 + 1;
}//while (n_1<129){

   board_list_816->eval = ocenka;
}//Eval_State(int chess_board[]){
//	*******************************************************************

//	===================================================================
//      
void Eval_adjustment_816(short int i,T_list_surplus_moves * list_surplus_moves,T_board_list_816 * board_list_816){


int ocenka= 0;
int dz= 0;
int depth = 0;
int x= 0;
int y= 0;
short int name_figure= 0;
short int  name_taking_figure= 0;
short int  description_move= 0;
//   (  )
short int  initial_position=0;
//   (  )
short int  final_position=0;

//          
//          
// 0-  1- 2- 3- 4- 5- 6-          
//        

//    ( ?)
depth = list_surplus_moves->current_depth;

//     
initial_position=list_surplus_moves->initial_position[i];
final_position=list_surplus_moves->final_position[i];

//  
name_figure=list_surplus_moves->name_figure[i];

//   
name_taking_figure=list_surplus_moves->name_taking_figure[i];
//  
description_move=list_surplus_moves->description_move [i];

ocenka= board_list_816->eval;

switch (description_move){

case 0 :
//1    -----------------------------------------------------------------------
          switch (name_figure){
//--------------------------------------------------------------------------------------
//  
           case 2 :// 
              ocenka= ocenka+2*(Rook_amoun_816(final_position,board_list_816)-Rook_amoun_816(initial_position,board_list_816));

              break;
           case 3 :// 
y = initial_position/16+1;
x= initial_position%16+1;
              ocenka= ocenka-xy_board_out(1,x,y,Pozicion);
y = final_position/16+1;
x= final_position%16+1;
             ocenka= ocenka+xy_board_out(1,x,y,Pozicion);

              break;
           case 4 :// 
y = initial_position/16+1;
x= initial_position%16+1;
              ocenka= ocenka-xy_board_out(1,x,y,Pozicion);
y = final_position/16+1;
x= final_position%16+1;
             ocenka= ocenka+xy_board_out(1,x,y,Pozicion);
              break;
           case 5 :// 
              break;
           case 6 :// 
y = initial_position/16+1;
x= initial_position%16+1;
              ocenka= ocenka-xy_board_out(1,x,y,Castling);
y = final_position/16+1;
x= final_position%16+1;
             ocenka= ocenka+xy_board_out(1,x,y,Castling);
              break;
           case 1 :// 
              dz= board_list_816->colour_figure_816[final_position]==1 ? 1 : 0;
y = initial_position/16+1;
x= initial_position%16+1;
              ocenka=ocenka-(dz*xy_board_out(1,x,y,Pawn)+(1-dz)*xy_board_out(1,x,9-y,Pawn));
y = final_position/16+1;
x= final_position%16+1;
              ocenka=ocenka+(dz*xy_board_out(1,x,y,Pawn)+(1-dz)*xy_board_out(1,x,9-y,Pawn));
              break;
//--------------------------------------------------------------------------------------
           default:
            break;
           }// switch (name_figure){
 break;
//--------------------------------------------------------------------------------------



   case 1 :
//2 ----------------------------------------------------------------------------------

 break;

   case 2 :
 //3   -----------------------------------------------------------------------

break;

  case 3 :
   //-----------------------------------------------------------------------

break;

  case 4 :
   //   

break;

   case 5 :
   //   

break;

   case 6 :
   //   

break;

  case 7 :
   //   

break;

  case 8 :
//     

break;

  case 9 :
//     

break;

  case 10 :
//     

   break;

  case 11 :
//     

break;

   default:;//  

}//switch (description_move){

   board_list_816->eval = ocenka;
}//Eval_State(int chess_board[]){
//	*******************************************************************

//	===================================================================
//       
int Eval_State_816(T_board_list_816 * board_list_816){

 //      
        int Structure_pawn_w[]={
	         0,
	         0,0,0,0,0,0,0,0,
		     0,0,0,0,0,0,0,0,
            };
        int Structure_pawn_b[]={
	         0,
	         0,0,0,0,0,0,0,0,
		     0,0,0,0,0,0,0,0,
            };

static  int ocenka=0;
static  int ocenka_p=0;

static  int zv=0;//  
static  int dz=0;
static  int n_1 = 0;
static  int x=0;
static  int y=0;
static short int name_figure=0;

 n_1 = 0;
 ocenka=0;
// ocenka_m=0;
 ocenka_p=0;

while (n_1<120){
    if (!(n_1 & 0x88)&&(board_list_816->colour_figure_816[n_1]!=0)){	
//          
//          
// 0-  1- 2- 3- 4- 5- 6-          
y = n_1/16+1;
x= n_1%16+1;
//        
zv= board_list_816->colour_figure_816[n_1]==1 ? 1 : -1;

//  
name_figure=board_list_816->name_figure_816[n_1];

          switch (name_figure){
//--------------------------------------------------------------------------------------
//  
           case 2 :// 
   //           ocenka_m= ocenka_m+zv*500;
              ocenka_p= ocenka_p+zv*xy_board_out(1,x,y,Pozicion_r);
              ocenka_p= ocenka_p+zv*2*Rook_amoun_816(n_1,board_list_816);

              break;
           case 3 :// 
   //           ocenka_m= ocenka_m+zv*300;
              ocenka_p= ocenka_p+zv*xy_board_out(1,x,y,Pozicion);
              break;
           case 4 :// 
   //           ocenka_m= ocenka_m+zv*300;
              ocenka_p= ocenka_p+zv*xy_board_out(1,x,y,Pozicion);
              ocenka_p= ocenka_p+zv*2*Bishop_amoun_816(n_1,board_list_816);
              break;
           case 5 :// 
   //           ocenka_m= ocenka_m+zv*1000;
              ocenka_p= ocenka_p+zv*xy_board_out(1,x,y,Pozicion_r);
        //      ocenka= ocenka+zv*2*Rook_amoun_816(n_1,board_list_816);
        //      ocenka= ocenka+zv*2*Bishop_amoun_816(n_1,board_list_816);
              break;
           case 6 :// 
  //         	  ocenka_m= ocenka_m+zv*900000;
              ocenka_p= ocenka_p+zv*xy_board_out(1,x,y,Castling);
              break;
           case 1 :// 
              dz= board_list_816->colour_figure_816[n_1]==1 ? 1 : 0;
  //            ocenka_m=ocenka_m+zv*100;
              ocenka_p=ocenka_p+zv*(dz*xy_board_out(1,x,y,Pawn)+(1-dz)*xy_board_out(1,x,9-y,Pawn));

//                
			  if(zv==1){
				  Structure_pawn_w[x]=Structure_pawn_w[x]+1;
			  }else{
                  Structure_pawn_b[x]=Structure_pawn_b[x]+1;
			  }//if(zv==1){

              break;
//--------------------------------------------------------------------------------------
           default:
            break;
        }//switch
 }//if ((board_list_816.colour_figure_816[n_1]!=3)&&(board_list_816.colour_figure_816[n]!=0)){	
  n_1 = n_1 + 1;
}//while (n_1<129){

//    
  for(int ii=1;ii<9;ii++){
    if(Structure_pawn_w[ii]>1)ocenka_p=ocenka_p-20*Structure_pawn_w[ii];
    if(Structure_pawn_b[ii]>1)ocenka_p=ocenka_p+20*Structure_pawn_b[ii];
  }//for(int ii=1;ii<9;ii++){
// ocenka = ocenka_p + ocenka_m; 

   return ocenka_p;
}//Eval_State(int chess_board[]){
//	*******************************************************************

//	===================================================================
//       
int Eval_forced_816(T_board_list_816 * board_list_816 ){

static  int ocenka_f=0;
static  int zv=0;//  
static  int n_1 = 0;
static short int name_figure=0;

 n_1 = 0;
 ocenka_f=0;

while (n_1<120){
    if (!(n_1 & 0x88)&&(board_list_816->colour_figure_816[n_1]!=0)){	

//        
zv= board_list_816->colour_figure_816[n_1]==1 ? 1 : -1;

//  
name_figure=board_list_816->name_figure_816[n_1];

          switch (name_figure){
           case 2 :// 
              ocenka_f= ocenka_f+zv*500;
           break;

           case 3 :// 
              ocenka_f= ocenka_f+zv*300;
           break;

           case 4 :// 
              ocenka_f= ocenka_f+zv*300;
           break;

           case 5 :// 
              ocenka_f= ocenka_f+zv*1000;
           break;

           case 6 :// 
           	  ocenka_f= ocenka_f+zv*900000;
           break;

           case 1 :// 
              ocenka_f=ocenka_f+zv*100;
           break;
//--------------------------------------------------------------------------------------
           default:
            break;
        }//switch
 }//if ((board_list_816.colour_figure_816[n_1]!=3)&&(board_list_816.colour_figure_816[n]!=0)){	
  n_1 = n_1 + 1;
}//while (n_1<129){

   return ocenka_f;
}//int Eval_forced_816(T_board_list_816 * board_list_816){
//	*******************************************************************


//	===================================================================T
//        
int Rook_amoun_816(short int n,T_board_list_816 * board_list_816){
short int n_1=0;
int m_0=0;//  
int m_1=0;// 

//   -16    |     + 1    -> 
//   + 16    |     - 1     <-
short int dR[]={-16,1,16,-1}; 

//    ..   
for (int i=0; i<4;i++){
  n_1 = n + dR[i];
//   --------------------------------------------------
//        ,      
  while ((!(n_1 & 0x88))&&(board_list_816->colour_figure_816[n]!=board_list_816->colour_figure_816[n_1])){
	 if (board_list_816->colour_figure_816[n_1]==0){
       m_0=m_0+1;
	 }else{
       m_1=m_1+1;
	   break;//     
	 }//if (board_list_816.colour_figure_816[n_1]!=0){ 
     n_1 = n_1 + dR[i];
  }//while (!(n_1 & 0*88)&&(board_list_816.colour_figure_816[n]!=board_list_816.colour_figure_816[n_1])){
//-----------------------------------------------------------------
}//for (int i=0; i<4;i++){
//    (     + )
//    20    20   21 ..   
 return m_0 + m_1;
 }//Rook_816(int n,int board_list_816.colour_figure_816[],T_list_surplus_moves list_surplus_moves){
//	*******************************************************************

//	===================================================================
//     
//    
int Bishop_amoun_816(short int n,T_board_list_816 * board_list_816){
short int n_1=0;
int m_0=0;//  
int m_1=0;// 
//   -15       + 17   
//   + 15        -17   
short int dB[]={-15,17,15,-17};

for (int i=0; i<4;i++){
  n_1 = n + dB[i];
//        ,      ,
  while ((!(n_1 & 0x88))&&(board_list_816->colour_figure_816[n]!=board_list_816->colour_figure_816[n_1])){
	 if (board_list_816->colour_figure_816[n_1]==0){
       m_0=m_0+1;
	 }else{
	   m_1=m_1+1;
	   break;//     
	 }//if (board_list_816.colour_figure_816[n_1]!=0){ 
     n_1 = n_1 + dB[i];
  }//while (!(n_1 & 0*88)&&(board_list_816.colour_figure_816[n]!=board_list_816.colour_figure_816[n_1])){
}//for (i=1; i<5;i++){
return m_0 + m_1;

}//Bishop_816(int n,int board_list_816.colour_figure_816[],T_list_surplus_moves * list_surplus_moves){
//	*******************************************************************
